/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vista;

import Negocio.BookProcess;
import Negocio.PrestamosProcess;
import Negocio.UserProcess;
import java.beans.PropertyVetoException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Abraham Fernandez Sanchez
 */

public class DevolucionLibroVista extends javax.swing.JInternalFrame {
    Escritorio escritorio ;
    PrestamosProcess prestamosProcess;
    BookProcess bookProcess;
    UserProcess userProcess;
    
 
 
    /**
     * Creates new form DevolucionLibroVista
     * @param escritorio Objeto de la clase Escritorio
     */
    public DevolucionLibroVista( Escritorio escritorio ) {
        this.escritorio=escritorio;
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldCarnet = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldISBN = new javax.swing.JTextField();
        jButtonAceptar = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setTitle("Devolucion Libro");

        jLabel1.setText("Nº Carnet :");

        jLabel2.setText("Nº ISBN :");

        jButtonAceptar.setText("Aceptar");
        jButtonAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAceptarActionPerformed(evt);
            }
        });

        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jButtonAceptar))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextFieldCarnet, javax.swing.GroupLayout.DEFAULT_SIZE, 200, Short.MAX_VALUE)
                    .addComponent(jTextFieldISBN)
                    .addComponent(jButtonCancelar, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap(22, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldISBN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldCarnet, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonAceptar)
                    .addComponent(jButtonCancelar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAceptarActionPerformed
        try {
            devolverLibro();
        } catch (SQLException ex) {
            Logger.getLogger(DevolucionLibroVista.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonAceptarActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed

        try {
            this.setClosed(true);//metodo para cerrar este frame
        } catch (PropertyVetoException ex) {
            Logger.getLogger(AddUsuarioVista.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    /**
     * 
     * @throws SQLException 
     */
    private void devolverLibro() throws SQLException{
        prestamosProcess = new PrestamosProcess(); 
        
        String nIsbn = jTextFieldISBN.getText();
        String carnet = jTextFieldCarnet.getText();
        
        
               
        if(prestamosProcess.devolverLibro(nIsbn, carnet)){
            JOptionPane.showMessageDialog(escritorio, "Se ha devuelto el libro con exito");
        }else{
            respuestasJOptionDevolucionLibroVista(nIsbn, carnet);
            JOptionPane.showMessageDialog(escritorio, "Ha ocurrido un error y no se ha podido realizar la operacionb de devolución");
        }
            
        try {
            this.setClosed(true);//metodo para cerrar este frame
        } catch (PropertyVetoException ex) {
            Logger.getLogger(AddUsuarioVista.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    /**
     * 
     * @param nIsbn
     * @param carnet
     * @throws SQLException 
     */
    private void respuestasJOptionDevolucionLibroVista(String nIsbn, String carnet) throws SQLException{
        bookProcess = new BookProcess();
        userProcess = new UserProcess();
        prestamosProcess = new PrestamosProcess();
        
        if(!bookProcess.isISBNExist(nIsbn)){ JOptionPane.showMessageDialog(escritorio, "El numero de ISBN no existe"); }
        if(!userProcess.isNumCarnetExist(carnet)){ JOptionPane.showMessageDialog(escritorio, "El numero de carnet de usuario no existe"); }        
        if(!prestamosProcess.isPrestadoBook(nIsbn, carnet)){ JOptionPane.showMessageDialog(escritorio, "No existe ningun prestamo activo asociado al ISBN solicitado");}
        if(prestamosProcess.isDevueltoBook(nIsbn, carnet)){ JOptionPane.showMessageDialog(escritorio, "La devolucion seleccionada ya ha sido realizada anteriormente");}        
        
//          el numero de Isbn no existe
//el numero de carnet del usuario no existe
//el usuario seleccionado no tiene ningun prestamo del libro solicitado, (no se puede devolver)

            
    
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAceptar;
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jTextFieldCarnet;
    private javax.swing.JTextField jTextFieldISBN;
    // End of variables declaration//GEN-END:variables
}
